-- $Id: $

local playerClassEN = "Priest";
local playerName    = "Elveram";

local debug = false
function debugMsg(arg)
  if (debug) then
    DEFAULT_CHAT_FRAME:AddMessage(arg);
  end
end

local enabled = "on"

local buffs   = {
    "Interface\\Icons\\Spell_Holy_SealOfSalvation",
    "Interface\\Icons\\Spell_Holy_GreaterBlessingofSalvation" };
local stances = {
    "Interface\\Icons\\Ability_Racial_BearForm",
    "Interface\\Icons\\Ability_Warrior_DefensiveStance",
    "Interface\\Icons\\Spell_Holy_SealOfFury" };

-- scheduled helper function to remove the buffs
local schedule_time   = 0;
local schedule_wait   = 2;
function SalvBegone_OnUpdate(elapsed)
  -- scheduled?
  schedule_time = schedule_time + elapsed;
  if (schedule_time < schedule_wait) then return end

  if (enabled == "off") then return end

  if (playerClassEN == "WARRIOR" or 
      playerClassEN == "DRUID" or 
      playerClassEN == "PALADIN") then
    local icb = 1;
    local bName ="";
    local texture ="";
    local is_tank = false;
    local has_salv = false;

    -- Check warrior exception
    if (playerClassEN == "WARRIOR") then
      local active = false;
      while true do
        texture,bName,active = GetShapeshiftFormInfo(icb);
        if not texture then break end
        debugMsg("SalvBegone: Found buff present : " .. bName .. " : " .. texture);
        if ( texture == "Interface\\Icons\\Ability_Warrior_DefensiveStance" ) then
          is_tank = active;
          if (is_tank) then
            debugMsg("SalvBegone: Warrior is in Defensive stance");
          end
          break
        end
        icb = icb + 1;
      end
    end

    icb = 1;
    while (not is_tank or not has_sav) do
      bName,_,texture,_,_,_ = UnitBuff("player",icb);
      if bName then
        icb = icb + 1;

        debugMsg("SalvBegone: Found buff present : " .. bName .. " : " .. texture);

        -- check if we are tank (not warriors)
        if ( not is_tank and not playerClassEN == "WARRIOR" ) then
          for _, stance in pairs(stances) do
            if (texture == stance) then
              is_tank = true;
              break;
            end
          end
        end

        -- find salv buff
        if ( not has_salv ) then
          for _, buff in pairs(buffs) do
            if (texture == buff) then
              has_salv = bName;
              break;
            end
          end
        end
      else
        do break end
      end
    end;

    if ( is_tank and has_salv ) then
      SalvBegone_Remove(has_salv);
    end
  else
    -- We can never be a tank
    SalvBegone_Command("off")
  end

  -- re-schedule
  schedule_time = 0;
end

function SalvBegone_Remove(buff)
  CancelPlayerBuff(buff);
  DEFAULT_CHAT_FRAME:AddMessage("SalvBegone: Removed " .. buff);
end

function SalvBegone_Command(msg)
  if (string.lower(msg) == "") then
    SalvBegone_Usage(0);
    return;
  end

  if (string.lower(msg) == "test") then
    local icb = 1;
    local bName ="";
    local texture ="";
    while true do
      bName,_,texture,_,_,_ = UnitBuff("target",icb);
      if bName then
        debugMsg("Found buff present : " .. bName .. " : " .. texture);
        icb = icb + 1;
      else
        do break end
      end
    end
  end

  if (string.lower(msg) == "credit") then
    DEFAULT_CHAT_FRAME:AddMessage("SalvBegone: Thanks to SalvationRemover for a start in the right direction," ..
    " and to all the (fail) pallies of Duskwood - EQ for making this necessary. -- Elveram");
  end

  if ( string.lower(msg) == "status" ) then
    DEFAULT_CHAT_FRAME:AddMessage("SalvBegone Loaded for : " .. playerName .. " (" .. playerClassEN ..")");
    DEFAULT_CHAT_FRAME:AddMessage("SalvBegone Status : " .. enabled);
  end

  if ( string.lower(msg) == "on" ) then
    enabled = "on";
    DEFAULT_CHAT_FRAME:AddMessage("SalvBegone Enabled");
  end

  if ( string.lower(msg) == "off" ) then
    enabled = "off";
    DEFAULT_CHAT_FRAME:AddMessage("SalvBegone Disabled");
  end

  if ( string.lower(msg) == "debug" ) then
    debug = not debug
    debugMsg("SalvBegone: debug messages enabled")
  end
end

function SalvBegone_Usage()
  DEFAULT_CHAT_FRAME:AddMessage("SalvBegone Usage: /salvbegone status | on | off | credits");
  SalvBegone_Command("status");
end

function SalvBegone_OnLoad()
  local playerClassLOC = "";
  playerClassLOC, playerClassEN = UnitClass("player")
  playerName  = UnitName("player")

  SLASH_SALVBEGONE1 = "/salvbegone";
  -- SLASH_SALVBEGONE2 = "/sbg";
  SlashCmdList["SALVBEGONE"] = SalvBegone_Command;

  -- this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS");
  this:RegisterEvent("ADDON_LOADED");

  DEFAULT_CHAT_FRAME:AddMessage("SalvBegone Loaded for : " .. playerName .. " (" .. playerClassLOC ..")");
end

